/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of sha256.xs. Do not edit this file, edit sha256.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "sha256.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "sha.h"
#include "sha512.h"

typedef struct digeststate {
  union {
    SHA_INFO sha_info;
    SHA_INFO512 sha_info512;
  } u;
  int digestsize;
} *Digest__SHA256;

#line 25 "sha256.c"

XS(XS_Digest__SHA256_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA256_new)
{
    dXSARGS;
    if (items < 0 || items > 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA256::new(digestsize=256)");
    {
	int	digestsize;
	Digest__SHA256	RETVAL;

	if (items < 1)
	    digestsize = 256;
	else {
	    digestsize = (int)SvIV(ST(0));
	}
#line 23 "sha256.xs"
      switch (digestsize) {
      case 256:
      case 384:
      case 512:
	break;
      default:
	croak("wrong digest size: digest must be either 256, 384, or 512 bits long");
	break;
      }
      Newz(0, RETVAL, 1, struct digeststate);
      RETVAL->digestsize = digestsize;
      switch (RETVAL->digestsize) {
      case 256:
	sha_init(&RETVAL->u.sha_info);
	break;
      case 384:
	sha_init384(&RETVAL->u.sha_info512);
	break;
      default:
	sha_init512(&RETVAL->u.sha_info512);
	break;
      }
#line 65 "sha256.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Digest::SHA256", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__SHA256_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA256_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA256::DESTROY(context)");
    {
	Digest__SHA256	context;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    context = INT2PTR(Digest__SHA256,tmp);
	}
	else
	    Perl_croak(aTHX_ "context is not a reference");
#line 52 "sha256.xs"
	{
	    safefree((char *) context);
	}
#line 92 "sha256.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Digest__SHA256_reset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA256_reset)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA256::reset(context)");
    {
	Digest__SHA256	context;

	if (sv_derived_from(ST(0), "Digest::SHA256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    context = INT2PTR(Digest__SHA256,tmp);
	}
	else
	    Perl_croak(aTHX_ "context is not of type Digest::SHA256");
#line 60 "sha256.xs"
	{
	  switch (context->digestsize) {
	  case 256:
	    sha_init(&context->u.sha_info);
	    break;
	  case 384:
	    sha_init384(&context->u.sha_info512);
	    break;
	  default:
	    sha_init512(&context->u.sha_info512);
	    break;
	  }
	}
#line 127 "sha256.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Digest__SHA256_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA256_add)
{
    dXSARGS;
    if (items < 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA256::add(context, ...)");
    {
	Digest__SHA256	context;

	if (sv_derived_from(ST(0), "Digest::SHA256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    context = INT2PTR(Digest__SHA256,tmp);
	}
	else
	    Perl_croak(aTHX_ "context is not of type Digest::SHA256");
#line 78 "sha256.xs"
	{
	  SV *svdata;
	  STRLEN len;
	  unsigned char *data;
	  int i;

	  for (i = 1; i < items; i++) {
	    data = (unsigned char *) (SvPV(ST(i), len));
	    switch (context->digestsize) {
	    case 256:  
	      sha_update(&context->u.sha_info, data, len);
	      break;
	    default:
	      sha_update512(&context->u.sha_info512, data, len);
	      break;
	    }
	  }
	}
#line 167 "sha256.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Digest__SHA256_digest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA256_digest)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA256::digest(context)");
    {
	Digest__SHA256	context;
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Digest::SHA256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    context = INT2PTR(Digest__SHA256,tmp);
	}
	else
	    Perl_croak(aTHX_ "context is not of type Digest::SHA256");
#line 102 "sha256.xs"
	{
	  Uint8 d_str[64];

	  switch (context->digestsize) {
	  case 256:
	    sha_final(&context->u.sha_info);
	    sha_unpackdigest(d_str, &context->u.sha_info);
	    break;
	  case 384:
	    sha_final512(&context->u.sha_info512);
	    sha_unpackdigest384(d_str, &context->u.sha_info512);
	    break;
	  default:
	    sha_final512(&context->u.sha_info512);
	    sha_unpackdigest512(d_str, &context->u.sha_info512);
	    break;
	  }

	  ST(0) = sv_2mortal(newSVpv(d_str, 64));
	}
#line 210 "sha256.c"
    }
    XSRETURN(1);
}


XS(XS_Digest__SHA256_length); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA256_length)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA256::length(self)");
    {
	Digest__SHA256	self;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Digest::SHA256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__SHA256,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Digest::SHA256");
#line 127 "sha256.xs"
       RETVAL = self->digestsize;
#line 235 "sha256.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Digest__SHA256); /* prototype to pass -Wmissing-prototypes */
XS(boot_Digest__SHA256)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXSproto("Digest::SHA256::new", XS_Digest__SHA256_new, file, ";$");
        newXSproto("Digest::SHA256::DESTROY", XS_Digest__SHA256_DESTROY, file, "$");
        newXSproto("Digest::SHA256::reset", XS_Digest__SHA256_reset, file, "$");
        newXSproto("Digest::SHA256::add", XS_Digest__SHA256_add, file, "$;@");
        newXSproto("Digest::SHA256::digest", XS_Digest__SHA256_digest, file, "$");
        newXSproto("Digest::SHA256::length", XS_Digest__SHA256_length, file, "$");
    XSRETURN_YES;
}

